#include "StdAfx.h"
#include "WASMyPage.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"


CWASMyPage::CWASMyPage(CWASActor *pActor) 
: CWASCommand(pActor)
, m_nSerialProfile(0)
, m_nSerialSpec(0)
, m_nSerialInviteBuddy(0)
, m_eOSType(osUnknown)
{
	m_nCategoryCacheSerial = 0;
}


CWASMyPage::~CWASMyPage(void)
{
}


void CWASMyPage::ExecuteAsync()
{
	m_sSpecInfo.Clear();
	m_listLevel.clear();

#if defined(WIN32)	
	USES_CONVERSION;
#endif	
	USES_UTF8_CONVERSION;

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/org/MyProfile.php");

	char szSerialProfile[100] = {0,};
	char szOSType[100] = {0,};
	char szSerialSpec[100] = {0,};
	char szSerialInvite[100] = {0,};

	sprintf(szSerialSpec, "%d", m_nSerialSpec);
	sprintf(szSerialInvite, "%d", m_nSerialInviteBuddy);
	sprintf(szSerialProfile, "%d", m_nSerialProfile);
	sprintf(szOSType, "%d", m_eOSType);

	m_httpFacade.session().SetURL( W2U8(strURL.c_str()), pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().AddBodyVariable("langcode", W2U8(m_strLangCode.c_str()));
	m_httpFacade.session().AddBodyVariable("tenant", W2U8(m_strTenantName.c_str()));

	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);
}


bool CWASMyPage::ParseAndEventFire(nfc::CIkXMLDom *pDom)
{
	if (pDom == NULL)
		return false;

	nfc::IIkXMLNode *pNode = NULL;
	nfc::IIkXMLAttribute *pAttr = NULL;
	nfc::IIkXMLNodeList *pChildList = NULL;
	USES_UTF8_CONVERSION;

	// User ⺻
	pNode = pDom->GetdocumentElement()->selectSingleNode("node");
	
	if (pNode)
	{
		pAttr = pNode->getAttribute("user_id");
		if(pAttr)
			m_sMyPage.strUserID = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("emp_nm");
		if (pAttr)
			m_sMyPage.strUserName = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("dept_nm");
		if(pAttr)
			m_sMyPage.strDeptName = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("jbps_nm");
		if(pAttr)
			m_sMyPage.strJbpsName = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("jbdt_nm");
		if(pAttr)
			m_sMyPage.strJbdtName = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("tel_no");
		if(pAttr)
			m_sMyPage.strIncomeTelNo = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("fax_no");
		if(pAttr)
			m_sMyPage.strFaxNo = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("cph_no");
		if(pAttr)
			m_sMyPage.strCphNo = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("ipph_no");
		if(pAttr)
			m_sMyPage.strIpphNo = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("inco_tel_no");
		if(pAttr)
			m_sMyPage.strExtensionTelNo = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("email_addr");
		if(pAttr)
			m_sMyPage.strEmailAddress = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("rmngph_no");
		if(pAttr)
			m_sMyPage.strRmngphNo = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("kwd_nm");
		if(pAttr)
			m_sMyPage.strKwdName = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("nickname");
		if(pAttr)
			m_sMyPage.strTalkName = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("function_list");
		if(pAttr)
			m_sMyPage.strFunction = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("service_id");
		if(pAttr)
			m_sMyPage.strServiceList = U82W(pAttr->Gettext().c_str());

		pAttr = pNode->getAttribute("legacy_link");
		if(pAttr)
			m_sMyPage.strLagacyLink = U82W(pAttr->Gettext().c_str());

	}

	const WCHAR *strFind = L"SC_12";

	if (m_sMyPage.strFunction.find(strFind) != string::npos)
	{
		nfc::IIkXMLNode* pNode = pDom->GetdocumentElement()->selectSingleNode("user_levels");
		nfc::IIkXMLAttribute* pAttr;
		if (pNode == NULL)
		{
			m_strWasErrMsg += _T("˻ Ϳ \" <user_levels>\"  ã  ϴ.");
			return true;
		}

		nfc::IIkXMLNodeList *pList = pNode->selectNodes("level");

		for (int i = 0; i < pList->Getlength(); i++)
		{
			NE_LEVEL_DATA sResult;

			pNode = pList->Getitem(i);
			GT_ASSERT(pNode);

			if (NULL != (pAttr = pNode->getAttribute("val")))
				sResult.nLevelVal = atoi(pAttr->Gettext().c_str());

			if (NULL != (pAttr = pNode->getAttribute("nm")))
				sResult.strLevelName = U82W(pAttr->Gettext().c_str());

			m_listLevel.push_back(sResult);
		}
	}

	return true;
}


//bool CWASMyPage::LoadFAQList(nfc::CIkXMLDom * pDom)
//{
//
//	if(pDom == NULL)
//		return false;
//
//	USES_UTF8_CONVERSION;
//
//	m_listFAQPrivate.clear();
//	m_listFAQ.clear();
//	do
//	{
//		nfc::IIkXMLNodeList * pList1 = pDom->GetdocumentElement()->selectNodes("nodes");
//		nfc::IIkXMLNodeList * pList2;
//	
//		// Tree Re-Construction
//		for(int i = 0; i < pList1->Getlength(); i++)
//		{
//			nfc::IIkXMLNode * pListNode = pList1->Getitem(i);
//			nfc::IIkXMLAttribute *pAttr = pListNode->getAttribute("name");
//			if(NULL == pAttr)
//				continue;
//
//			if(pAttr->Gettext() != "FAQList")
//				continue;
//			
//			pList2 = pListNode->selectNodes("node");
//			
//			for(int k = 0; k < pList2->Getlength(); k++)
//			{
//				P_GT_FAQ_DATA sFAQData;
//
//				nfc::IIkXMLNode * pNode = pList2->Getitem(k);
//				nfc::IIkXMLAttribute *pAttr = pNode->getAttribute("order");
//				if(NULL == pAttr)
//					continue;
//				sFAQData.nDisplayOrder = atoi(pAttr->Gettext().c_str());
//
//				pAttr = pNode->getAttribute("priority");
//				if(NULL == pAttr)
//					continue;
//				sFAQData.nDisplayPriority = atoi(pAttr->Gettext().c_str());
//
//				pAttr = pNode->getAttribute("title");
//				if(NULL == pAttr)
//					continue;
//				sFAQData.strTitle = U82W(pAttr->Gettext().c_str());
//
//				pAttr = pNode->getAttribute("url");
//				if(NULL == pAttr)
//					continue;
//				sFAQData.strURL = U82W(pAttr->Gettext().c_str());
//
//				m_listFAQPrivate.push_back(sFAQData);
//			}
//		}
//	} while(FALSE);
//	return true;
//}


//bool CWASMyPage::LoadSpecInfo(nfc::CIkXMLDom * pDom)
//{
//    USES_UTF8_CONVERSION;
//    
//	nfc::IIkXMLNode *pNode = NULL;
//	nfc::IIkXMLAttribute *pAttr = NULL;
//
//	if(pDom == NULL)
//		return false;
//
//	pNode = pDom->GetdocumentElement()->selectSingleNode("spec");
//	if (NULL == pNode)
//	{
//		// may be success if mobile or serial same..
//		return true;
//	}
//
//	pAttr = pNode->getAttribute("max_buddy");
//	if (pAttr)
//		m_sSpecInfo.nMaxBuddyCount = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("max_buddygroup");
//	if (pAttr)
//		m_sSpecInfo.nMaxBuddyGroupCount = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("max_favoriteroom");
//	if (pAttr)
//		m_sSpecInfo.nMaxRoomFavoriteCount = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("max_memo_send_box");
//	if (pAttr)
//		m_sSpecInfo.nMaxMemoSendBox = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("max_memo_recv_box");
//	if (pAttr)
//		m_sSpecInfo.nMaxMemoRecvBox = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("max_memo_save_box");
//	if (pAttr)
//		m_sSpecInfo.nMaxMemoSaveBox = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("memo_request_cnt");
//	if (pAttr)
//		m_sSpecInfo.nCountRequestMemoBox = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("mobile_request_cnt");
//	if (pAttr)
//		m_sSpecInfo.nCountRequestMobileUserInfo = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("mobile_expire_sec_hash");
//	if (pAttr)
//		m_sSpecInfo.nCheckExpireSecondMobilePhoneHash = atoi(pAttr->Gettext().c_str());
//	
////	pAttr = pNode->getAttribute("mobile_expire_sec_installflag");
////	if (pAttr)
////		m_sSpecInfo.nCheckExpireSecondMobileInstallFlag = atoi(pAttr->Gettext().c_str());
////
//	pAttr = pNode->getAttribute("mobile_hash_version");
//	if (pAttr)
//		m_sSpecInfo.nVersionMobilePhoneHashAlgotithm = atoi(pAttr->Gettext().c_str());
//	
//	pAttr = pNode->getAttribute("detect_game_interval");
//	if (pAttr)
//		m_sSpecInfo.nIntervalDetectGame = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("login_ping_interval");
//	if (pAttr)
//		m_sSpecInfo.nIntervalPingToLoginServer = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("login_ticket_interval");
//	if (pAttr)
//		m_sSpecInfo.nIntervalTicketToLoginServer = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("use_p2p_tcp");
//	if (pAttr)
//		m_sSpecInfo.bUseP2P_TCP = atoi(pAttr->Gettext().c_str()) == 1 ? true : false;
//
//	pAttr = pNode->getAttribute("use_p2p_udp");
//	if (pAttr)
//		m_sSpecInfo.bUseP2P_UDP = atoi(pAttr->Gettext().c_str()) == 1 ? true : false;
//
//    pAttr = pNode->getAttribute("emergency_patch");
//	if (pAttr)
//		m_sSpecInfo.bEmergencyPatchFlag = atoi(pAttr->Gettext().c_str()) == 1 ? true : false;
//
//    pAttr = pNode->getAttribute("new_version");
//	if (pAttr)
//		m_sSpecInfo.strClientNewVersion = pAttr->Gettext().c_str();
//    
//    pAttr = pNode->getAttribute("max_limit_roomusercnt");
//	if (pAttr)
//		m_sSpecInfo.nMaxRoomLimitUserCount = atoi(pAttr->Gettext().c_str());
//
//    pAttr = pNode->getAttribute("max_concurrent_roomusercnt");
//	if (pAttr)
//		m_sSpecInfo.nMaxRoomConcurrentUserCount = atoi(pAttr->Gettext().c_str());
//
//	pAttr = pNode->getAttribute("room_accuse_text_save_cnt");
//	if (pAttr)
//		m_sSpecInfo.nRmAccuseTextSaveCnt = atoi(pAttr->Gettext().c_str());
//
//	return true;
//}

//bool CWASMyPage::LoadCacheInfo(nfc::CIkXMLDom * pDom)
//{
//	nfc::IIkXMLNode *pNode = NULL;
//	nfc::IIkXMLAttribute *pAttr = NULL;
//
//	if(pDom == NULL)
//		return false;
//
//	// Room Category Cache 
//	pNode = pDom->GetdocumentElement()->selectSingleNode("rcache");
//	if (NULL == pNode)
//	{
//		m_strWasErrMsg += _T("[CWASMyPage::LoadCacheInfo] http response xml data INVALID. A necessary node \"<rcache>\" is omited.");
//		return false;
//	}
//
//	pAttr = pNode->getAttribute("serial");
//	if (pAttr)
//		m_nCategoryCacheSerial = atoi(pAttr->Gettext().c_str());
//
//	return true;
//}


// override in drived class
void CWASMyPage::OnWasResponse(trid_t trid,
							   bool bSuccess,
							   int /*nWinINetErrorCode*/, 
							   int /*nHttpResponseCode*/, 
                               LPCSTR szWasResCodeInHeader, 
                               LPCSTR szWasResCodeInXml,
                               nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}

	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();

	GT_MYPAGE_DATA sData;
	m_sMyPage.Convert(sData);

	GT_API_SPEC_DATA sSpec;
	GT_FAQ_DATA_LIST sListFAQ;
	
	NE_LEVEL_DATA_LIST sList;
	sList.nSize = m_listLevel.size();
	sList.pList = sList.nSize > 0 ? &m_listLevel[0] : NULL;

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseMyPage(m_pActor, GetID(), m_eError, sData, sSpec, sListFAQ, sList, m_nCategoryCacheSerial) == false)
			break;
	}

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASMyPage::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t observers;
	m_pActor->GetObserversEx(&observers);
	CGTObserved<IGTWASActorEventPrivate>::listobserver_t::iterator it = observers.begin();

	GT_MYPAGE_DATA sData;
	m_sMyPage.Convert(sData);

	GT_API_SPEC_DATA sSpec;
	m_sSpecInfo.Convert(sSpec);

	GT_FAQ_DATA_LIST sListFAQ;
	for(size_t i = 0; i < m_listFAQPrivate.size(); i++)
	{
		GT_FAQ_DATA sTemp;
		m_listFAQPrivate[i].Convert(sTemp);
		m_listFAQ.push_back(sTemp);
	}
	sListFAQ.nSize = m_listFAQ.size();
	sListFAQ.pList = sListFAQ.nSize > 0 ? &m_listFAQ[0] : NULL;

	NE_LEVEL_DATA_LIST sList;
	sList.nSize = m_listLevel.size();
	sList.pList = sList.nSize > 0 ? &m_listLevel[0] : NULL;

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEventPrivate *pObserver = static_cast<IGTWASActorEventPrivate *>(*it);
		if(pObserver->OnGTWASActor_ResponseMyPage(m_pActor, GetID(), m_eError, sData, sSpec, sListFAQ, sList, m_nCategoryCacheSerial) == false)
			break;
	}

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
